//===========================================================================
//=
//=  Copyright (C) 2008 Maxim Integrated Products
//=  All rights Reserved. Printed in U.S.A.
//=
//=  Permission is hereby granted, free of charge, to any person obtaining a
//=  copy of this software and associated documentation files (the 
//=  "Software"), to deal in the Software without restriction, including
//=  without limitation the rights to use, copy, modify, merge, publish,
//=  distribute, sublicense, and/or sell copies of the Software, and to
//=  permit persons to whom the Software is furnished to do so, subject to
//=  the following conditions:
//=  
//=  The above copyright notice and this permission notice shall be included
//=  in all copies or substantial portions of the Software source code.
//=  
//=  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
//=  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
//=  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//=  IN NO EVENT SHALL MAXIM INTEGRATED PRODUCTS BE LIABLE FOR ANY CLAIM, 
//=  DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
//=  OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR 
//=  THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//=
//=  Except as contained in this notice, the name of Maxim Integrated Products
//=  shall not be used except as stated in the Maxim Branding Policy.
//=
//=     Description: MAXQ2000 uIP Ethernet Example Application
//=                 
//=        Filename: util.c
//=
//=        Compiler: Rowley CrossWorks C compiler
//=
//=        Hardware: MAXQ2000 Evaluation Kit (Rev B)
//=
//===========================================================================

#include "util.h"
#include "cprintf.h"


/* Dump a buffer in hexadecimal and printable ASCII format to the console
 *
 * Input arguments:
 *
 *   b - byte buffer to dump
 *   len - number of bytes to dump
 *
 * Returns:
 *
 *   <none>
 *
 */
void hexdump(unsigned char *b, unsigned int len)
{
  int x, c;
  int line;

  cprintf(C"ADDR|  0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F | ASCII\r\n");
  cprintf(C"------------------------------------------------------------------------\r\n");
  for (line = 0; line < ((len % 16) ? (len / 16) + 1 : (len / 16)); line++) {
    cprintf(C"%04X| ", line * 16);
    for (x = 0; x < 16; x++) {
      if (x + (line * 16) < len) {
        c = b[x+line*16];
        cprintf(C"%02x ", c);
      } else {
        cprintf(C"   ");
      }
    }
    cprintf(C"| ");
    for (x = 0; x < 16; x++) {
      if (x + (line * 16) < len) {
        c = b[x+line*16];
        if ((c > 0x1f) && (c < 0x7f)) {
          cprintf(C"%c", c);
        } else {
          cprintf(C".");
        }
      } else {
        cprintf(C" ");
      }
    }
    cprintf(C"\r\n");
  }
  cprintf(C"------------------------------------------------------------------------\r\n");
}
